﻿local format, mod = string.format, mod
local date, time = date, time
local FORCE_UPDATE = 100
local COLOR_WHITE = "|cffffffff%s|r"

local delay = 1
local counter = 0
local localTime

--local function GetTipAnchor(frame)
--	local x,y = frame:GetCenter()
--	if not x or not y then return "TOPLEFT", "BOTTOMLEFT" end
--	local hhalf = (x > UIParent:GetWidth()*2/3) and "RIGHT" or (x < UIParent:GetWidth()/3) and "LEFT" or ""
--	local vhalf = (y > UIParent:GetHeight()/2) and "TOP" or "BOTTOM"
--	return vhalf..hhalf, frame, (vhalf == "TOP" and "BOTTOM" or "TOP")..hhalf
--end

local Clock = CreateFrame("Frame")
Clock.obj = LibStub("LibDataBroker-1.1"):NewDataObject("aBroker_Clock", {
	text  = "00:00",
	OnClick = function(self, btn)
		if btn == "LeftButton" then
			ToggleTimeManager()
		else
			ToggleCalendar()
		end
	end,
	
	OnEnter = function(self)
		if not IsAddOnLoaded("Blizzard_TimeManager") then LoadAddOn("Blizzard_TimeManager") end
		GameTooltip:SetOwner(self, "ANCHOR_BOTTOMRIGHT") --"ANCHOR_NONE")
		--GameTooltip:SetPoint(GetTipAnchor(self))
		TimeManagerClockButton_UpdateTooltip()
		GameTooltip:AddLine("Right-click to open calendar.")
		GameTooltip:Show()
	end,
	OnLeave = function() GameTooltip:Hide() end,
})

function Clock:OnUpdate(elapsed)
	counter = counter + elapsed
	if counter >= delay then
		localTime = format(COLOR_WHITE, date("%H"))..":"..format(COLOR_WHITE, date("%M"))..":"..format(COLOR_WHITE, date("%S"))
		self.obj.text = localTime
		counter = 0
	end
end


function Clock:ADDON_LOADED(event, addon)
	if addon == "aBroker_Clock" then
		self:OnUpdate(FORCE_UPDATE)
		self:UnregisterEvent("ADDON_LOADED")
		self:SetScript("OnEvent", nil)
		self.ADDON_LOADED = nil
	end
end

Clock:SetScript("OnUpdate", Clock.OnUpdate)
Clock:SetScript("OnEvent", Clock.ADDON_LOADED)
Clock:RegisterEvent("ADDON_LOADED")
