﻿
local Mail = CreateFrame("Frame", "aBroker_Mail")
Mail.obj = LibStub("LibDataBroker-1.1"):NewDataObject("aBroker_Mail", {icon = "Interface\\AddOns\\Broker_Mail\\nomail", label = "Mailbox"})

local L_NEW = "New Mail"
local L_NONE = "No Mail"

Mail:RegisterEvent("UPDATE_PENDING_MAIL")
Mail:RegisterEvent("MAIL_INBOX_UPDATE")
Mail:RegisterEvent("PLAYER_LOGIN")
Mail:SetScript("OnEvent", function()
	if HasNewMail() then
		Mail.obj.icon = "Interface\\AddOns\\aBroker_Mail\\newmail"
		Mail.obj.text = L_NEW
	else
		Mail.obj.icon = "Interface\\AddOns\\aBroker_Mail\\nomail"
		Mail.obj.text = L_NONE
	end
end)

function Mail.obj.OnTooltipShow(tip)
	if not tip or not tip.AddLine then return end

	local a, b, c = GetLatestThreeSenders()
	tip:AddLine(_G["HAVE_MAIL_FROM"])
	if a then tip:AddLine(a) end
	if b then tip:AddLine(b) end
	if c then tip:AddLine(c) end
end

MiniMapMailFrame:UnregisterAllEvents()
MiniMapMailFrame:Hide()
