local xbar, rbar, fontst
  
local kilo = function(value)
	if value >= 1e6 then
		return string.format("%.2fm", value/1e6)
	elseif value >= 1e3 then
		return string.format("%.1fk", value/1e3)
	else
		return value
	end	
end
   
local function rbar_ReSetValue(rxp, xp, mxp)
    if rxp then
		if rxp+xp >= mxp then
			rbar:SetValue(mxp)
		else
			rbar:SetValue(rxp+xp)
		end
    else
		rbar:SetValue(0)
    end
end  
  
local function aXPBar_ShowXP(rxp, xp, mxp)
    xbar:SetStatusBarColor(0.2,0.2,0.99, 0.85)
    xbar:SetMinMaxValues(0,mxp)
    xbar:SetValue(xp)
    rbar:SetMinMaxValues(0,mxp)
    rbar_ReSetValue(rxp, xp, mxp)
	fontst:SetFormattedText("%s | %s  (%s%%)",kilo(xp),kilo(mxp),floor((xp/mxp)*1000)/10)
end
  
local function aXPBar_ShowRep()
    name, standing, minrep, maxrep, value = GetWatchedFactionInfo()
    if name then
		xbar:SetStatusBarColor(FACTION_BAR_COLORS[standing].r, FACTION_BAR_COLORS[standing].g, FACTION_BAR_COLORS[standing].b, 0.85)
		xbar:SetMinMaxValues(minrep,maxrep)
		xbar:SetValue(value)
		rbar:SetValue(0)
		fontst:SetFormattedText("%s: %s | %s  (%s%%)",name,kilo(value-minrep),kilo(maxrep-minrep),floor(((value-minrep)/(maxrep-minrep))*1000)/10)
	else
		mxp = UnitXPMax("player")
		xp = UnitXP("player")
		rxp = GetXPExhaustion()
		aXPBar_ShowXP(rxp, xp, mxp)
    end
end
    
local function aXPBar_OnEvent(this, event, arg1, arg2, arg3, arg4, ...)
    mxp = UnitXPMax("player")
    xp = UnitXP("player")
    rxp = GetXPExhaustion()
    
    if event == "PLAYER_ENTERING_WORLD" then
		if UnitLevel("player") == MAX_PLAYER_LEVEL then
			aXPBar_ShowRep()
		else
			aXPBar_ShowXP(rxp, xp, mxp)
		end
    elseif event == "PLAYER_LEVEL_UP" then
		if UnitLevel("player") == MAX_PLAYER_LEVEL then
			aXPBar_ShowRep()
		else
			aXPBar_ShowXP(rxp, xp, mxp)
		end
	elseif event == "PLAYER_XP_UPDATE" and arg1 == "player" then
		if UnitLevel("player") == MAX_PLAYER_LEVEL then
			aXPBar_ShowRep()
		else
			aXPBar_ShowXP(rxp, xp, mxp)
		end
		--xbar:SetValue(xp)
		--fontst:SetFormattedText("%s | %s  (%s%%)",kilo(xp),kilo(mxp),floor((xp/mxp)*1000)/10)
		--rbar_ReSetValue(rxp, xp, mxp)
    elseif event == "MODIFIER_STATE_CHANGED" then
		if arg1 == "LCTRL" or arg1 == "RCTRL" then
			if arg2 == 1 then
				aXPBar_ShowRep()
			elseif arg2 == 0 and UnitLevel("player") ~= MAX_PLAYER_LEVEL then
				aXPBar_ShowXP(rxp, xp, mxp)
			end
		end
    elseif event == "UPDATE_FACTION" then
		if UnitLevel("player") == MAX_PLAYER_LEVEL then
			aXPBar_ShowRep()
		end
    end
end
  
local function aXPBar_OnEnter()
    mxp = UnitXPMax("player")
    xp = UnitXP("player")
    rxp = GetXPExhaustion()
    name, standing, minrep, maxrep, value = GetWatchedFactionInfo()
	if(IsModifiedClick()) then
		GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR")
		GameTooltip:AddLine("aXPBar")
		if UnitLevel("player") ~= MAX_PLAYER_LEVEL then
			GameTooltip:AddDoubleLine(COMBAT_XP_GAIN, xp.."|cffffd100/|r"..mxp.." |cffffd100/|r "..floor((xp/mxp)*1000)/10 .."%",NORMAL_FONT_COLOR.r,NORMAL_FONT_COLOR.g,NORMAL_FONT_COLOR.b,1,1,1)
			if rxp then
				GameTooltip:AddDoubleLine(TUTORIAL_TITLE26, rxp .." |cffffd100/|r ".. floor((rxp/mxp)*1000)/10 .."%", NORMAL_FONT_COLOR.r,NORMAL_FONT_COLOR.g,NORMAL_FONT_COLOR.b,1,1,1)
			end
			if name then
				GameTooltip:AddLine(" ")      
			end
		end
		if name then
			GameTooltip:AddDoubleLine(FACTION, name, NORMAL_FONT_COLOR.r,NORMAL_FONT_COLOR.g,NORMAL_FONT_COLOR.b,1,1,1)
			GameTooltip:AddDoubleLine(STANDING, getglobal("FACTION_STANDING_LABEL"..standing), NORMAL_FONT_COLOR.r,NORMAL_FONT_COLOR.g,NORMAL_FONT_COLOR.b,FACTION_BAR_COLORS[standing].r, FACTION_BAR_COLORS[standing].g, FACTION_BAR_COLORS[standing].b)
			GameTooltip:AddDoubleLine(REPUTATION, value-minrep .."|cffffd100/|r"..maxrep-minrep.." |cffffd100/|r "..floor((value-minrep)/(maxrep-minrep)*1000)/10 .."%", NORMAL_FONT_COLOR.r,NORMAL_FONT_COLOR.g,NORMAL_FONT_COLOR.b,1,1,1)
		end
		GameTooltip:Show()
	end
end
  
local function bf_OnLeave()
	GameTooltip:Hide()
end

local function create_xpbars()  
	local f = CreateFrame("Frame","aXPBar",UIParent)
    f:SetFrameStrata("BACKGROUND")
    f:SetFrameLevel(4)
    f:SetWidth(546)
    f:SetHeight(18)
	f:SetPoint("BOTTOM",0,5)
	
	local f2 = CreateFrame("Frame","aXPBar2",UIParent)
    f2:SetFrameStrata("BACKGROUND")
    f2:SetFrameLevel(1)
    f2:SetWidth(546)
    f2:SetHeight(18)
	f2:SetAllPoints(f)

    local back = f2:CreateTexture(nil,"BACKGROUND")
    back:SetTexture("Interface\\AddOns\\aXPBar\\media\\statusbar.tga")
    back:SetVertexColor(0.9,0.9,0.9,0.7)
    back:SetAllPoints(f2)
	
    local xpbar = CreateFrame("StatusBar", nil, f2)
    xpbar:SetStatusBarTexture("Interface\\AddOns\\aXPBar\\media\\statusbar.tga")
    xpbar:SetStatusBarColor(0.2,0.2,0.99,0.85)
    xpbar:SetFrameStrata("BACKGROUND")
    xpbar:SetFrameLevel(3)
    xpbar:SetAllPoints(f2)
    xpbar:SetMinMaxValues(0,1)
    xpbar:SetValue(0)
	xbar = xpbar
	
    local repbar = CreateFrame("StatusBar", nil, f2)
    repbar:SetStatusBarTexture("Interface\\AddOns\\aXPBar\\media\\statusbar.tga")
    repbar:SetStatusBarColor(1,0.6,1,0.85)
    repbar:SetFrameStrata("BACKGROUND")
    repbar:SetFrameLevel(2)
    repbar:SetAllPoints(f2)
    repbar:SetMinMaxValues(0,1)
    repbar:SetValue(0)
	rbar = repbar
    
    local fonts = f:CreateFontString(nil, "OVERLAY")
	fonts:SetFontObject(GameFontHighlight)
    fonts:SetPoint("TOP",f2,"TOP",0,-2)
	fonts:SetJustifyH("CENTER")
	fonts:SetTextColor(1,1,1,1)
	fontst = fonts
    
	f2:EnableMouse(true)
    f2:SetScript("OnEvent", aXPBar_OnEvent)
    f2:SetScript("OnEnter", aXPBar_OnEnter)
    f2:SetScript("OnLeave", aXPBar_OnLeave)
    f2:RegisterEvent("PLAYER_XP_UPDATE")
    f2:RegisterEvent("PLAYER_LEVEL_UP")
    f2:RegisterEvent("PLAYER_ENTERING_WORLD")
    f2:RegisterEvent("UPDATE_FACTION")
    f2:RegisterEvent("MODIFIER_STATE_CHANGED")
end



local a = CreateFrame"Frame"
a:RegisterEvent("VARIABLES_LOADED")
a:SetScript("OnEvent", function(self)
	self:SetScript("OnEvent", nil)    
	create_xpbars()
	end
)