--[[doc
h1. Plugin API: Money

*Description:*
	Creates a frame which shows the player's money

*Spawns with:*
*	:SpawnPlugin("Money"): spawn a frame with the player's money
*	:SpawnPlugin("Money", "static"): spawn a frame with a static amount of money
*	:SpawnPlugin("Money, frame): change the frame into a frame of the player's money

*Money callbacks functions:*
*	:UpdateMoney(cost): To set the amount of money in copper
doc]]

-- Update the display
local function updater(self, event)
	if((not event or event == "PLAYER_MONEY" or event == "PLAYER_LOGIN") and self.UpdateMoney) then
		local cost = cargBags:GetHandler().GetMoney()
		self:UpdateMoney(cost)
	end
end

-- Register the plugin
local count = 0
cargBags:RegisterPlugin("Money", function(self, arg1)
	local frame
	if(type(arg1) ~= "table") then
		-- Create our own frame
		count = count + 1
		frame = CreateFrame("Frame", self.Name.."Money"..count, self, "SmallMoneyFrameTemplate")
		MoneyFrame_SetType(frame, "STATIC")
		frame.UpdateMoney = MoneyFrame_Update
	else
		-- Use delivered frame
		frame = arg1
	end
	frame.Object = self

	if((arg1) ~= "static") then
		cargBags:AddCallback(frame, updater)
	end
	return frame
end)