﻿local INVITE_WORD = "invx"
local SCREENSHOT_QUALITY = 7

local autorollgreens = false
local AutoRepair = true
local SellGreyCrap = true 
local autoUIscale = true
local MoveScoreFrameAndCaptureBar = true
	local ScoreFramePosition = {"BOTTOM", UIParent, "TOPLEFT", 100, -90}
	local CaptureBarPosition = {"TOPLEFT", UIParent, "TOPLEFT", 35, -75}
local HideErrors = true
local autoacceptDE = false
local autodeclineduel = true
local autoaccceptinvite = true

---------------- > Some slash commands
SlashCmdList['RELOADUI'] = function() ReloadUI() end
SLASH_RELOADUI1 = '/rl'
SLASH_RELOADUI2 = '/кд'

SlashCmdList["TICKET"] = function() ToggleHelpFrame() end
SLASH_TICKET1 = "/пь"
SLASH_TICKET2 = "/gm"

SlashCmdList["READYCHECKSLASHRC"] = function() DoReadyCheck() end
SLASH_READYCHECKSLASHRC1 = '/rc'
SLASH_READYCHECKSLASHRC2 = '/кс'

SlashCmdList["DISABLE_ADDON"] = function(s) DisableAddOn(s) print(s, format("|cffd36b6b disabled")) end
SLASH_DISABLE_ADDON1 = "/dis"   -- You need to reload UI after enabling/disabling addon

SlashCmdList["ENABLE_ADDON"] = function(s) EnableAddOn(s) print(s, format("|cfff07100 enabled")) end
SLASH_ENABLE_ADDON1 = "/en"   -- You need to reload UI after enabling/disabling addon

SlashCmdList["SETBARS"] = function() if IsAddOnLoaded("Dominos") then Dominos:SetProfile("mono") else print("Dominos is not loaded!") end end
SLASH_SETBARS1 = '/setbars'

-- combatlog manual reset 
SlashCmdList["CLCE"] = function() CombatLogClearEntries() end
SLASH_CLCE1 = "/cl"

-- a command to show frame you currently have mouseovered
SlashCmdList["FRAME"] = function(arg)
	if arg ~= "" then
		arg = _G[arg]
	else
		arg = GetMouseFocus()
	end
	if arg ~= nil and arg:GetName() ~= nil then
		local point, relativeTo, relativePoint, xOfs, yOfs = arg:GetPoint()
		ChatFrame1:AddMessage("|cffCC0000~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~")
		ChatFrame1:AddMessage("Name: |cffFFD100"..arg:GetName())
		if arg:GetParent() then
			ChatFrame1:AddMessage("Parent: |cffFFD100"..arg:GetParent():GetName())
		end
 		ChatFrame1:AddMessage("Width: |cffFFD100"..format("%.2f",arg:GetWidth()))
		ChatFrame1:AddMessage("Height: |cffFFD100"..format("%.2f",arg:GetHeight()))
		ChatFrame1:AddMessage("Strata: |cffFFD100"..arg:GetFrameStrata())
		ChatFrame1:AddMessage("Level: |cffFFD100"..arg:GetFrameLevel())
 		if xOfs then
			ChatFrame1:AddMessage("X: |cffFFD100"..format("%.2f",xOfs))
		end
		if yOfs then
			ChatFrame1:AddMessage("Y: |cffFFD100"..format("%.2f",yOfs))
		end
		if relativeTo then
			ChatFrame1:AddMessage("Point: |cffFFD100"..point.."|r anchored to "..relativeTo:GetName().."'s |cffFFD100"..relativePoint)
		end
		ChatFrame1:AddMessage("|cffCC0000~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~")
	elseif arg == nil then
		ChatFrame1:AddMessage("Invalid frame name")
	else
		ChatFrame1:AddMessage("Could not find frame info")
	end
end
SLASH_FRAME1 = "/frame"
SLASH_FRAME2 = "/gf"

-- spec switching
SlashCmdList["SPEC"] = function() 
local spec = GetActiveTalentGroup()
if spec == 1 then SetActiveTalentGroup(2) elseif spec == 2 then SetActiveTalentGroup(1) end
end
SLASH_SPEC1 = "/ss"
SLASH_SPEC2 = "/spec"

 -- auction house addons set 
SlashCmdList["ENABLE_AUC"] = function() 
EnableAddOn("Auctionator")
EnableAddOn("Panda")
EnableAddOn("Fence")
print(format("|cff84ba69 Auction/trade modules are enabled, reload UI for changes to take place")) end
SLASH_ENABLE_AUC1 = "/aucon"

SlashCmdList["DISABLE_AUC"] = function() 
DisableAddOn("Auctionator")
DisableAddOn("Panda")
DisableAddOn("Fence")
print(format("|cffd36b6b Auction/trade modules are disabled, reload UI for changes to take place")) end
SLASH_DISABLE_AUC1 = "/aucoff"

---------------- > Setting Dominos default profile on first load
if IsAddOnLoaded("Dominos") then
	local profile = Dominos.db:GetCurrentProfile()
	local pclass = UnitClass("player")
	if profile == pclass then
		Dominos:SetProfile("mono")
	end
end

---------------- > Propper Ready Check sound
local ShowReadyCheckHook = function(self, initiator, timeLeft)
	if initiator ~= "player" then PlaySound("ReadyCheck") end
end
hooksecurefunc("ShowReadyCheck", ShowReadyCheckHook)

---------------- > automatic UI Scale 
if autoUIscale then
	local scalefix = CreateFrame("Frame")
	scalefix:RegisterEvent("PLAYER_LOGIN")
	scalefix:SetScript("OnEvent", function()
		SetCVar("useUiScale", 1)
		SetCVar("uiScale", 0.85)
	end)
end
---------------- > Max camera distance, screenshots quality
SetCVar("cameraDistanceMax", 50)
SetCVar("cameraDistanceMaxFactor", 3.4)
SetCVar("screenshotQuality", SCREENSHOT_QUALITY)

---------------- > AutoRepair and sell grey junk
local g = CreateFrame("Frame")
g:RegisterEvent("MERCHANT_SHOW")
g:SetScript("OnEvent", function()    
	if(AutoRepair==true and CanMerchantRepair()) then
			  local cost = GetRepairAllCost()
		if cost > 0 then
			local money = GetMoney()
			if IsInGuild() then
				local guildMoney = GetGuildBankWithdrawMoney()
				if guildMoney > GetGuildBankMoney() then
					guildMoney = GetGuildBankMoney()
				end
				if guildMoney > cost and CanGuildBankRepair() then
					RepairAllItems(1)
					print(format("|cfff07100Repair cost covered by G-Bank: %.1fg|r", cost * 0.0001))
					return
				end
			end
			if money > cost then
					RepairAllItems()
					print(format("|cffead000Repair cost: %.1fg|r", cost * 0.0001))
			else
				print("Go farm newbie.")
			end
		end
	end 
    if(SellGreyCrap==true) then
        local bag, slot 
        for bag = 0, 4 do
            for slot = 0, GetContainerNumSlots(bag) do
                local link = GetContainerItemLink(bag, slot)
                if link and (select(3, GetItemInfo(link))==0) then
                    UseContainerItem(bag, slot)
                end
            end
        end
    end
end)

---------------- > Moving TicketStatusFrame
TicketStatusFrame:ClearAllPoints()
TicketStatusFrame:SetPoint("TOPLEFT",UIParent,"TOPLEFT")
TicketStatusFrame.SetPoint = function() end

---------------- > Moving Battlefield score frame 
if MoveScoreFrameAndCaptureBar then
if (WorldStateAlwaysUpFrame) then
	WorldStateAlwaysUpFrame:ClearAllPoints()
	WorldStateAlwaysUpFrame:SetPoint(unpack(ScoreFramePosition))
	WorldStateAlwaysUpFrame:SetScale(0.9)
	WorldStateAlwaysUpFrame.SetPoint = function() end
end 

---------------- > Moving CaptureBar
local f = CreateFrame("Frame")
local function OnEvent()
    if(NUM_EXTENDED_UI_FRAMES>0) then
            for i = 1, NUM_EXTENDED_UI_FRAMES do
                _G["WorldStateCaptureBar" .. i]:ClearAllPoints()
                _G["WorldStateCaptureBar" .. i]:SetPoint(unpack(CaptureBarPosition))
            end
    end
end

local f = CreateFrame"Frame"
f:RegisterEvent"PLAYER_LOGIN"
f:RegisterEvent"UPDATE_WORLD_STATES"
f:RegisterEvent"UPDATE_BATTLEFIELD_STATUS"
f:SetScript("OnEvent", OnEvent)
end
---------------- > ALT+Click to buy a stack
hooksecurefunc("MerchantItemButton_OnModifiedClick", function(self, button)
    if MerchantFrame.selectedTab == 1 then
        if IsAltKeyDown() and button=="RightButton" then
            local id=self:GetID()
			local quantity = select(4, GetMerchantItemInfo(id))
            local extracost = select(7, GetMerchantItemInfo(id))
            if not extracost then
                local stack 
				if quantity > 1 then
					stack = quantity*GetMerchantItemMaxStack(id)
				else
					stack = GetMerchantItemMaxStack(id)
				end
                local amount = 1
                if self.count < stack then
                    amount = stack / self.count
                end
                if self.numInStock ~= -1 and self.numInStock < amount then
                    amount = self.numInStock
                end
                local money = GetMoney()
                if (self.price * amount) > money then
                    amount = floor(money / self.price)
                end
                if amount > 0 then
                    BuyMerchantItem(id, amount)
                end
            end
        end
    end
end)

---------------- > Hiding default blizzard's Error Frame (thx nightcracker)
if HideErrors then
local f, o, ncErrorDB = CreateFrame("Frame"), "No error yet.", {
	["Inventory is full"] = true,
}
f:SetScript("OnEvent", function(self, event, error)
	if ncErrorDB[error] then
		UIErrorsFrame:AddMessage(error)
	else
	o = error
	end
end)
SLASH_NCERROR1 = "/error"
function SlashCmdList.NCERROR() print(o) end
UIErrorsFrame:UnregisterEvent("UI_ERROR_MESSAGE")
f:RegisterEvent("UI_ERROR_MESSAGE")
end

---------------- > Autoinvite by whisper
local f = CreateFrame("frame")
f:RegisterEvent("CHAT_MSG_WHISPER")
f:SetScript("OnEvent", function(self,event,arg1,arg2)
    if (not UnitExists("party1") or IsPartyLeader("player")) and arg1:lower():match(INVITE_WORD) then
        InviteUnit(arg2)
    end
end)

---------------- > Disband Group
local GroupDisband = function()
	local pName = UnitName("player")
	if UnitInRaid("player") then
	SendChatMessage("Disbanding group.", "RAID")
		for i = 1, GetNumRaidMembers() do
			local name, _, _, _, _, _, _, online = GetRaidRosterInfo(i)
			if online and name ~= pName then
				UninviteUnit(name)
			end
		end
	else
		SendChatMessage("Disbanding group.", "PARTY")
		for i = MAX_PARTY_MEMBERS, 1, -1 do
			if GetPartyMember(i) then
				UninviteUnit(UnitName("party"..i))
			end
		end
	end
	LeaveParty()
end

StaticPopupDialogs["DISBAND_RAID"] = {
	text = "Do you really want to disband this group?",
	button1 = YES,
	button2 = NO,
	OnAccept = GroupDisband,
	timeout = 0,
	whileDead = 1,
}

SlashCmdList["GROUPDISBAND"] = function()
	StaticPopup_Show("DISBAND_RAID")
end
SLASH_GROUPDISBAND1 = '/radisband'
SLASH_GROUPDISBAND2 = '/disband'
SLASH_GROUPDISBAND3 = '/rd'

---------------- > Autogreed on greens © tekkub
if autorollgreens then
	local f = CreateFrame("Frame", nil, UIParent)
	f:RegisterEvent("START_LOOT_ROLL")
	f:SetScript("OnEvent", function(_, _, id)
	if not id then return end -- What the fuck?
	local _, _, _, quality, bop, _, _, canDE = GetLootRollItemInfo(id)
	if quality == 2 and not bop then RollOnLoot(id, canDE and 3 or 2) end
	end)
end

---------------- > ©tekKrush by tekkub
if autoacceptDE then
--	if GetNumRaidMembers() > 0 then return end
	local f = CreateFrame("Frame")
	f:RegisterEvent("CONFIRM_DISENCHANT_ROLL")
	f:SetScript("OnEvent", function(self, event, id, rollType)
		for i=1,STATICPOPUP_NUMDIALOGS do
			local frame = _G["StaticPopup"..i]
			if frame.which == "CONFIRM_LOOT_ROLL" and frame.data == id and frame.data2 == rollType and frame:IsVisible() then StaticPopup_OnClick(frame, 1) end
		end
	end)
end

---------------- > Auto decline duels
if autodeclineduel then
    local dd = CreateFrame("Frame")
    dd:RegisterEvent("DUEL_REQUESTED")
    dd:SetScript("OnEvent", function(self, event, name)
		HideUIPanel(StaticPopup1)
		CancelDuel()
		print(format("You have declined |cffFFC354"..name.."'s duel."))
    end)
end

---------------- > Accept invites from guild or friend list 
if autoaccceptinvite then
	local IsFriend = function(name)
		for i=1, GetNumFriends() do if(GetFriendInfo(i)==name) then return true end end
		if(IsInGuild()) then for i=1, GetNumGuildMembers() do if(GetGuildRosterInfo(i)==name) then return true end end end
	end

	local ai = CreateFrame("Frame")
	ai:RegisterEvent("PARTY_INVITE_REQUEST")
	ai:SetScript("OnEvent", function(frame, event, name)
	if(IsFriend(name)) then
		AcceptGroup()
		print("Group invitation from |cffFFC354"..name.."|r accepted.")
			for i = 1, 4 do
				local frame = _G["StaticPopup"..i]
				if(frame:IsVisible() and frame.which=="PARTY_INVITE") then
					frame.inviteAccepted = 1
					StaticPopup_Hide("PARTY_INVITE")
					return
				end
			end
		else
			SendWho(name)
		end
	end)
end

---------------- > Temporary stuff(fixes) for beta
--[[	FeedbackUI Fix
	by SDPhantom
	http://www.phantomweb.org	]]
------------------------------------------
local function PatchWrapper()
------------------------------------------------------------------------------------------
--[[	Replacement code for FeedbackUI_CompanionHook()
	Original code throws an error if the player has more than 12 critter companions	]]
------------------------------------------------------------------------------------------
function FeedbackUI_CompanionHook() end
hooksecurefunc("SpellBookCompanionButton_OnModifiedClick",function(self)
	if IsModifiedClick("GENERATEFEEDBACK") then
		local pettype=SpellBookCompanionsFrame.mode;--	"CRITTER" or "MOUNT"
		local petid=(SPELLBOOK_PAGENUMBERS[SpellBookFrame.bookType]-1)*NUM_COMPANIONS_PER_PAGE+self:GetID();--	Companion ID
		FeedbackUI_SetupSpawn(select(2,GetCompanionInfo(pettype,petid)),pettype=="CRITTER" and 1 or 2);--	Preps FeedbackUI
	end
end);
end

if IsAddOnLoaded("Blizzard_FeedbackUI") then
	PatchWrapper();
else
	local eframe=CreateFrame("Frame");
	eframe:RegisterEvent("ADDON_LOADED");
	eframe:SetScript("OnEvent",function(self,event,...)
		if event=="ADDON_LOADED" and (...)=="Blizzard_FeedbackUI" then
			PatchWrapper();
		end
	end);
end
