if not oUF then return end

-- Compares two icons for sorting
local function sortIcons(a, b)
    local auras = a:GetParent()
    local frame = auras:GetParent()
    local settings = frame.sortAuras
    local unit, filter = frame.unit, auras.filter
        
    local nameA, _, _, countA, debuffTypeA, _, expiresA, isMineA, isStealableA = UnitAura(unit, a.oUF_AuraSort_index, filter)
    local nameB, _, _, countB, debuffTypeB, _, expiresB, isMineB, isStealableB = UnitAura(unit, b.oUF_AuraSort_index, filter)
        
    if(not expiresA) then expiresA = -1 end
    if(not expiresB) then expiresB = -1 end

    local result

    if(settings.selfFirst) then
        if(isMineA == isMineB) then
            result = expiresA > expiresB
        else
            result = isMineA and true or false
        end
    else
        result = expiresA > expiresB
    end
    
    if(settings.reverse) then result = not result end
    return result
end

-- Overrides the layouts SetAuraPosition function with a new one that will sort the auras
local function OverrideSetAuraPosition(self, icons, visible)
    if(self.oUF_AuraSort_SetAuraPosition) then self.oUF_AuraSort_SetAuraPosition(self, icons, visible) end -- If layout has its own SetAuraPosition function already then call it
    if(visible <= 0) then return end
    
    -- Make a copy of the icon list and then sort it
    local sorted = {}
    
    for i = 1, visible do
        icons[i].oUF_AuraSort_index = i
        sorted[i] = icons[i]
    end
    sort(sorted, sortIcons)
    
    -- Iterate through each icon then find the match for its ID in the new sorted list. Once found reset the order of the icons with the final icon order
    local final = {}
    for i = 1, visible do final[i] = sorted[icons[i]:GetID()] end
    for i = 1, visible do icons[i] = final[i] end
    
    oUF:SetAuraPosition(icons, visible)
end

-- Applies aura sorting to a oUF layout frame
local function applyAuraSorting(object)
    if(not object.sortAuras) then return end
    
    -- Store any predefined functions layout has, if any
    if(object.SetAuraPosition) then object.oUF_AuraSort_SetAuraPosition = object.SetAuraPosition end
    
    -- Override old functions with new ones
    object.SetAuraPosition = OverrideSetAuraPosition
end

local f = CreateFrame("Frame", nil)
f:SetScript("OnEvent", function(s, e)
    for _, object in pairs(oUF.objects) do applyAuraSorting(object) end
end)
f:RegisterEvent("PLAYER_LOGIN")